> For the complete documentation index, see [llms.txt](https://docs.notcentralised.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.notcentralised.com/contracts/service-bus.md).

# Service Bus

## Overview of the ConfidentialServiceBus Contract

The `ConfidentialServiceBus` is a critical part of the NotVault SDK. Its core functionality lies in providing a confidential service bus that makes use of a zkSNARK verifier to ensure the creator of the message knows the value of the hash being published.

### Contract Structure

The `ConfidentialServiceBus` contract encompasses the following main components:

1. **Events**:
   * `set_value`: An event emitted when a new value is set, including the owner's address, the key, the value, and the block timestamp.
2. **Functions**:
   * `getValue`: A view function that retrieves a value from `valuesMap` using an owner's address and a key.
   * `setValue`: A function that verifies a zkSNARK proof and then sets a value in the `valuesMap`. It emits the `set_value` event.

### Functions Description

* **getValue Function**

  This function retrieves a value from the `valuesMap` for a given owner and a key. It is a view function and hence does not alter the state of the contract. The function signature is as follows:

  ```solidity
  function getValue(address owner, uint256 key) public view returns (uint256);
  ```
* **setValue Function**

  This function sets a value in the `valuesMap` after verifying a provided zkSNARK proof. It emits a `set_value` event that contains the owner's address, the key, the value, and the block timestamp. The function signature is:

  ```solidity
  function setValue(bytes calldata proof, uint[2] memory input) public;
  ```

This contract provides a confidential service bus using the power of zkSNARKs and an EVM compatible blockchain. This approach ensures that the data's integrity is maintained while keeping the original value confidential, hence the name `ConfidentialServiceBus`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.notcentralised.com/contracts/service-bus.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
